import React, { useRef, useState } from "react";
import { usePicker } from "./context";
import usePaintHue from "./usePaintHue";
import { barWrapStyles, barInnerStyles, handleStyles } from "./styles";

const Hue = () => {
  const barRef = useRef(null);
  const { handleHue, internalHue } = usePicker();
  const [dragging, setDragging] = useState(false);
  usePaintHue(barRef);

  const stopDragging = () => {
    setDragging(false);
  };

  const handleDown = () => {
    setDragging(true);
  };

  const handleMove = e => {
    if (dragging) {
      handleHue(e);
    }
  };

  const handleClick = e => {
    if (!dragging) {
      handleHue(e);
    }
  };

  return (
    <div
      style={barWrapStyles}
      onMouseEnter={stopDragging}
      onMouseLeave={stopDragging}
    >
      <div
        style={{ ...barInnerStyles, position: "relative" }}
        onMouseUp={stopDragging}
      >
        <div
          style={{ position: "relative", cursor: "crosshair" }}
          onMouseMove={e => handleMove(e)}
        >
          <div
            style={{
              left: internalHue * 0.766666666666667,
              top: 2,
              ...handleStyles
            }}
            onMouseDown={handleDown}
          />
          <canvas
            ref={barRef}
            width="294px"
            height="14px"
            style={{ position: "relative", borderRadius: 14 }}
            onClick={e => handleClick(e)}
          />
        </div>
      </div>
    </div>
  );
};

export default Hue;
